function Generadores_9sx4p_distintosMuestras(serie,modenserie,Pnom)


%UTILIDAD:
    %dibuja la curva I-V y P-V de los modulos de un seguidor 9sx4p(con todos sus modulos distintos)y sus PMP y de trabajo.
    %Y calcula la pot. nominal, la de trabajo, la suma de Pot. maximas y las perdidas por dispersion y totales de cada mod. y del seguidor.


%VARIABLES DE ENTRADA:
    %serie: n de 
    
warning off 
%Crea las matrices para "X"(series) y "Z"(modenseries) del grafico 3D.
cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        X(k,i)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
        Y(k,i)=z(contador);
        contador=contador+1;
    end
end
    
%Lee los datos de todos los 72 (36*2) modulos diferentes.
[V,I]= curvaIVnmodulos;
mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

%Lee los datos de todos los 288(72*2*2) modulos diferentes.
mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end
for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Sin conexion.
%for i=1:length(modenserie)
%   for t=1:length(serie)
%       [Vsinc{t,i} Isinc{t,i} Vser{t,i} Iser{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
%       for p=1:length(Vsinc{t,i})
%           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
%       end
%       PsincMAX(t,i)=max(Psinc{t,i});
%       Pideal(t,i)=Pnom*modenserie(i)*serie(t);
%       PerdidasTOTsinc(t,i)=(Pideal(t,i)-PsincMAX(t,i))/Pideal(t,i);
%   end
%end

%for t=1:length(serie)
%    for i=1:length(modenserie)
%        Psuma_de_maximas(t,i)=0;
%        for p=1:serie(t)*modenserie(i)
%            Psuma_de_maximas(t,i)=Psuma_de_maximas(t,i)+ max(P(p,:));
%        end
%    end
%end

%Sin conexion.
for i=2:2
   for t=1:length(serie)
       [Vsinc{t,i} Isinc{t,i} Vser{t,i} Iser{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
       for p=1:length(Vsinc{t,i})
           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
       end
       PsincMAX(t,i)=max(Psinc{t,i});
       Pideal(t,i)=Pnom*modenserie(i)*serie(t);
       PerdidasTOTsinc(t,i)=(Pideal(t,i)-PsincMAX(t,i))/Pideal(t,i);
   end
end

for t=1:length(serie)
    for i=2:2
        Psuma_de_maximas(t,i)=0;
        for p=1:serie(t)*modenserie(i)
            Psuma_de_maximas(t,i)=Psuma_de_maximas(t,i)+ max(P(p,:));
        end
    end
end

%Sin conexion.
for i=1:length(modenserie)
   for t=2:2
       [Vsinc{t,i} Isinc{t,i} Vser{t,i} Iser{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
       for p=1:length(Vsinc{t,i})
           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
           if Psinc{t,i}(1,p)==max(Psinc{t,i}(1,:))
               lugarGEN(t,i)=p;
           end
       end
       PsincMAX(t,i)=max(Psinc{t,i});
       
       Pideal(t,i)=Pnom*modenserie(i)*serie(t);
       PerdidasTOTsinc(t,i)=(Pideal(t,i)-PsincMAX(t,i))/Pideal(t,i);
   end
end

for t=2:2
    for i=1:length(modenserie)
        Psuma_de_maximas(t,i)=0;
        for p=1:serie(t)*modenserie(i)
            Psuma_de_maximas(t,i)=Psuma_de_maximas(t,i)+ max(P(p,:));
        end
    end
end
        
figure
[C,h]=contourf(X,Y,PerdidasTOTsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title('PerdidasTOTsinc');

%Dibuja las curvas de los modulos para una configuracion 9sx4p. y sus puntos de maxima potencia.
figure
for i=1:36
    hold on
    plot(V(i,:),I(i,:));
    for t=1:size(P,2)
        if P(i,t)==max(P(i,:))
            lugar(i)=t;
        end
    end
    plot(V(i,lugar(i)),max(P(i,:)),'k*');
    xlabel('Tensin (V)');
	ylabel('Corriente (A), Potencia (W)');
    title('9sx4p');
end

%Calcula la potencia de trabajo de los 5 primeros modulos de cada configuracion con 4 series o con 4 modulos en serie.
    %calcula la corriente de cada serie.
for t=1:5
    for i=1:length(serie)
        if t<4 %porque hay 4 modulos en serie.
            [Iseriereal{t}(i)]=extrapola2ju(Vser{serie(i),2}(1,:),Iser{serie(i),2}(1,:),Vsinc{serie(i),2}(1,lugarGEN(serie(i),2)));
            [Vmodserie{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
             Pmodserie{t}(i)=Vmodserie{t}(i)*Iser{serie(i),2}(1);
        else
            [Iseriereal{t}(i)]=extrapola2ju(Vser{serie(i),2}(2,:),Iser{serie(i),2}(2,:),Vsinc{serie(i),2}(1,lugarGEN(serie(i),2)));
            [Vmodserie{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodserie{t}(i)=Vmodserie{t}(i)*Iser{serie(i),2}(2);
        end
    end
    for i=1:length(modenserie)
        if t<modenserie(i) 
            [Iseriereal{t}(i)]=extrapola2ju(Vser{2,modenserie(i)}(1,:),Iser{2,modenserie(i)}(1,:),Vsinc{2,modenserie(i)}(1,lugarGEN{2,modenserie(i)}));
            [Vmodmoden{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodmoden{t}(i)=Vmodmoden{t}(i)*Iser{2,modenserie(i)}(1);
        elseif modenserie(i)<t && t<modenserie(i)*2
            [Iseriereal{t}(i)]=extrapola2ju(Vser{serie(i),2}(2,:),Iser{2,modenserie(i)}(2,:),Vsinc{2,modenserie(i)}(1,lugarGEN{2,modenserie(i)}));
            [Vmodmoden{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodmoden{t}(i)=Vmodmoden{t}(i)*Iser{2,modenserie(i)}(2);
        elseif (modenserie(i)*2)<t  &&  t<modenserie(i)*3
            [Iseriereal{t}(i)]=extrapola2ju(Vser{2,modenserie(i)}(2,:),Iser{2,modenserie(i)}(2,:),Vsinc{2,modenserie(i)}(1,lugarGEN{2,modenserie(i)}));
            [Vmodmoden{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodmoden{t}(i)=Vmodmoden{t}(i)*Iser{2,modenserie(i)}(3);
        end
        
    end
    
end
        


%Pone en una hoja excel las perdidas totales y las perdidas por dispersion para diferente n serieS y 4 modulos en serie.

celda{1,5}='PRDIDAS POR DISPERSIN';
celda{1,6}='PRDIDAS TOTALES';

celda{2,2}='?Pmax. sin defecto';
celda{2,3}='?Pmax. con defecto';
celda{2,4}='P.de trabajo';
celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

celda{3,1}='GENERADORES';

    %Escribe en excel las perdidas de 5 modulos(los 5 primeros)de cada generador, es decir, de para cad n de series.
inicio=13;
for t=1:5
    for i=1:length(serie)
     celda{inicio+i,1}=[num2str(serie(i)),'series'];
    end
    inicio=inicio+9;
end


inicio=13;
mod=1;
for i=1:5
celda{inicio,1}=['Mdulo',num2str(mod)];
inicio=inicio+9;
mod=mod+1;
end

for i=1:length(serie)
    celda{3+i,1}=[num2str(serie(i)),'series'];
    celda{3+i,2}=Pideal(serie(i),4);
    celda{3+i,3}=P_suma_de_maximas(serie(i),4);
    celda{3+i,4}= PsincMAX(serie(i),4);
    celda{3+i,5}=(celda{3+i,3}-celda{3+i,4})/celda{3+i,2};
    celda{3+i,6}=(celda{3+i,2}-celda{3+i,4})/celda{3+i,2};
end

inicio=13;
for i=1:5;
    for t=1:length(serie)
        celda{inicio+i,2}=Pnom;
        celda{inicio+i,3}=max(P(i,:));
        celda{inicio+i,4}=Pmodserie{i}(t);
        celda{inicio+i,5}=(celda{inicio+i,3}-celda{inicio+i,4})/celda{inicio+i,2};
        celda{inicio+i,6}=(celda{inicio+i,2}-celda{inicio+i,4})/celda{inicio+i,2};
    end
    inicio=inicio+9;
end
    
%Pone en una hoja excel las perdidas totales y las perdidas por dispersion para diferente n de modulos en serie y 4 series.

celda{1,5}='PRDIDAS POR DISPERSIN';
celda{1,6}='PRDIDAS TOTALES';

celda{2,2}='?Pmax. sin defecto';
celda{2,3}='?Pmax. con defecto';
celda{2,4}='P.de trabajo';
celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

celda{3,1}='GENERADORES';

    %Escribe en excel las perdidas de 5 modulos(los 5 primeros)de cada generador, es decir, de para cad n de series.
inicio=13;
for t=1:5
    for i=1:length(modenserie)
     celda{inicio+i,1}=[num2str(modenserie(i)),'modulos en serie'];
    end
    inicio=inicio+9;
end


inicio=13;
mod=1;
for i=1:5
celda{inicio,1}=['Mdulo',num2str(mod)];
inicio=inicio+9;
mod=mod+1;
end

for i=1:length(modenserie)
    celda{3+i,1}=[num2str(modenserie(i)),'modulos en serie'];
    celda{3+i,2}=Pideal(4,modenserie(i));
    celda{3+i,3}=P_suma_de_maximas(4,modenserie(i));
    celda{3+i,4}= PsincMAX(4,modenserie(i));
    celda{3+i,5}=(celda{3+i,3}-celda{3+i,4})/celda{3+i,2};
    celda{3+i,6}=(celda{3+i,2}-celda{3+i,4})/celda{3+i,2};
end

inicio=13;
for i=1:5;
    for t=1:length(modenserie)
        celda{inicio+i,2}=Pnom;
        celda{inicio+i,3}=max(P(i,:));
        celda{inicio+i,4}=Pmodmoden{i}(t);
        celda{inicio+i,5}=(celda{inicio+i,3}-celda{inicio+i,4})/celda{inicio+i,2};
        celda{inicio+i,6}=(celda{inicio+i,2}-celda{inicio+i,4})/celda{inicio+i,2};
    end
    inicio=inicio+9;
end

    nombre_hoja='ESTUDIO N MODULOS EN SERIE MODULOS DISTINTOS';
    rango='A1';
    xlswrite(('C:\Users\usuario\Desktop\pfc\pfc\DISTINTOS'),celda,nombre_hoja,rango);
    
end



