function [Vparalelo, Iparalelo]=paralelo2stringsju(V1,I1,V2,I2) %calacula la tension y coriente de dos series en paralelo.

    if I1(1)>I1(length(I1)),
        I1=sort(I1);
        V1=sort(V1,2,'descend');
    end                                     % Por las caracteristicas de nuestro extrapola es necesrio operar siempre con corrientes crecientes
    
    if I2(1)>I2(length(I2)),
        I2=sort(I2);
        V2=sort(V2,2,'descend');
    end                                     % lo mismo que antes
        
Vpar=sort([V1 V2]);     % agrupamos las tensiones de los dos strings
Vpar=Vpar([end:-2:1]);  % y cogemos slo una de cada dos

for n=1:length(Vpar)    % Barrido de tensiones 
    
    % hallamos las corrientes del string 1
    Ipar1(n)=extrapola2ju(V1,I1,Vpar(n));    % Calculo de la corriente del string 1, en funcion de las tensiones de referencia
    if Ipar1(n)<0 
        Ipar1(n)=0; end         % si la corriente es negativa el diodo se bloquea y la corriente se anula.
    
    % hallamos las corrientes del string 2
    Ipar2(n)=extrapola2ju(V2,I2,Vpar(n));    % Calculo de la corriente del string 2, en funcion de las tensiones de referencia
    if Ipar2(n)<0 
        Ipar2(n)=0; end         % si la corriente es negativa el diodo se bloquea y la corriente se anula.    
    
end 

Iparalelo=Ipar1+Ipar2; 
Vparalelo=Vpar;


%PARA VER EL RESULTADO.quitar!!
%Ipar{1}=Ipar1;
%Ipar{2}=Ipar2;
%Ipar{3}=Iparalelo;

%for i=1:size(Vparalelo,2)
%Pparalelo{1}(1,i)=Vparalelo(1,i)*Ipar1(1,i)/1000;
%Pparalelo{2}(1,i)=Vparalelo(1,i)*Ipar2(1,i)/1000;
%end
%Pmax{1}=max(Pparalelo{1});
%Pmax{2}=max(Pparalelo{2});

%for i=1:2
 %   if i==1
  %      a='def';
   % else
    %    a='mod2';
    %end
%celdaser{1,9}='Itot';
%celdaser{1,1}=['V',a,];
%celdaser{1,2}=['I',a];
%celdaser{1,1}=['P',a];
%celdaser{size(Vparalelo,2)+3,3}=['P.max',a];
%celdaser{size(Vparalelo,2)+4,3}=Pmax{i};
%for k=1:size(Vparalelo,2)
%    celdaser{k+1,1}=Vparalelo(1,k);
 %   celdaser{k+1,2}=Ipar{i}(1,k); 
 %   celdaser{k+1,3}=Pparalelo{i}(1,k);
 %   if i==1
 %   celdaser{k+1,9}=Ipar{3}(1,k);
 %   end
%end


%if i==1
%rango='A1';
%elseif i==2
%    rango='E1';
%end

%nombre_hoja='modenparalelo';
%xlswrite(['C:\Users\usuario\Desktop\pfc\ESTUDIOS\UnaconexionPRU'],celdaser,nombre_hoja,rango);
end
%FIN ESTUDIO SERIE DEF.

