function [Vserie,Iserie]=serie2stringsju(V1,I1,V2,I2)%calcula la tensio y corriente de dos series en serie, o de dos modulos en serie.
 %V1,I1,V2,I2 son vectores FILA!!!


    if I1(1)>I1(length(I1)), 
        I1=sort(I1);                         %ordena de menor a mayor.
        V1=sort(V1,2,'descend');            %orden de mayor a menor las columnas.
    end                                     % Por las caracteristicas de nuestro extrapola es necesrio operar siempre con corrientes crecientes
    
    if I2(1)>I2(length(I2)), 
        I2=sort(I2);
        V2=sort(V2,2,'descend');
    end                                     % lo mismo que antes
    


    % corrientes de referencia, para los que se calcularan las tensiones
    
    Iser=sort([I1 I2]);  % agrupamos las corrientes de los dos strings.
    Iser=Iser(1:2:end);  % y cogemos slo una de cada dos
    
    for n=1:length(Iser)  % Barrido de corrienes de la curva caracteristica de los strings
        
       % hallamos las tensiones del string 1
      
       Vser1(n)=extrapola2ju(I1,V1,Iser(n));    % Calculo de la tension del string 1, en funcion de las corrientes de referencia
       if Vser1(n)<0 
           Vser1(n)=0;
       end         % Si la tension es negativa el diodo de paso conduce y se hace cero
       
       % hallamos las tensiones del string 2
       Vser2(n)=extrapola2ju(I2,V2,Iser(n));    % Calculo de la tension del string 2, en funcion de las corrientesde referencia
       if Vser2(n)<0 
           Vser2(n)=0;
       end         % Si la tension es negativa el diodo de paso conduce y se hace cero
       
    end 
    
    Iserie=Iser;         
    Vserie=Vser1+Vser2;
  
    
    posIsc=max(find((Vserie>-0.01)&(Vserie<0.01)));%calcula la medida mas cercana a V=O qu se conoce.
    if isempty(posIsc)%si no se ha encontrado algun dato entre -0.01 y 0.01.
        Isc=extrapola2ju(Vserie,Iserie,0);
        Iserie=cat(2,Iserie(2:end),Isc);%aade a los datos de corriente(excepto los 2 primeros)la Isc calculada.
        Vserie=cat(2,Vserie(2:end),0);%aade el dato de V=O.
    end
    posVoc=max(find((Iserie>-0.01)&(Iserie<0.01)));
    if isempty(posVoc)
        Voc=extrapola2ju(Iserie,Vserie,0);
        Iserie=cat(2,0,Iserie(1:end-1));
        Vserie=cat(2,Voc,Vserie(1:end-1));
    end
   
end
    