function [Vsegui Isegui Pmax]= calculoseguidorju(ser,modenserie,Ordenmodulosenseries,segui,Dsegui) % nos calcula la curva total del seguidor, segun el numero de modulos y la forma de conectarlos
%Vtot=matriz :columnas=numero de medida, filas=numero de modulo medido.
%Itot=matriz :columnas=numero de medida, filas=numero de modulo medido.
%ser=numero de series.
%modenserie=numero de elementos en serie.
%Ordenmodulosenseries=vector fila que contiene el orden de los modulos conforme se desean repartir.
                  
warning off 
%Paso los datos de cada modulo a la matriz N y creo V e I.
n=1;
for k=1:length(segui)
figure
nombredatos{k}=Dsegui{k}(1).name;
for i=1:36
nombre=['Modulo',num2str(i)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui{1,k},'\',nombredatos{k}],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:length(N)-3,:);
if k==1 || k==2 || k==3
    V{k}(:,i)=N(:,1);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I{k}(:,i)=N(:,2);
%PARA DIBUJAR MODULOSquitar!!
    for q=1:size(V{k},1)
    P{k}(q,i)=V{k}(q,i)*I{k}(q,i);
    end
%FINquitar!!
elseif k==8 || k==7
V{k}(:,i)=N(:,8);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I{k}(:,i)=N(:,9);
%PARA DIBUJAR MODULOSquitar!!
    for q=1:size(V{k},1)
    P{k}(q,i)=V{k}(q,i)*I{k}(q,i);
    end
%FINquitar!!
else
V{k}(:,i)=N(:,15);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I{k}(:,i)=N(:,16);
%PARA DIBUJAR MODULOSquitar!!
    for q=1:size(V{k},1)
    P{k}(q,i)=V{k}(q,i)*I{k}(q,i);
    end
%FINquitar!!
end   
end
Vtot{k}=V{k}';
Itot{k}=I{k}';

%PARA DIBUJAR MODULOSquitar!!
Ptot{k}=P{k}';
for s=1:36
for q=1:size(Ptot{k},2)
    if max(Ptot{k}(s,:))==Ptot{k}(s,q)
        lugar=q;
    end
end
hold on
plot(Vtot{k}(s,:),Itot{k}(s,:),'r');
plot(Vtot{k}(s,lugar),Itot{k}(s,lugar),'b*');
end

%FIN DIBUJAR MOD.quitar!!

[Vsegui{k} Isegui{k} Vseries{k} Iseries{k}]= calculoseguidor2(Vtot{k},Itot{k},ser,modenserie,Ordenmodulosenseries);

for i=1:size(Vsegui{k},2)
Psegui{k}(1,i)=Vsegui{k}(1,i)*Isegui{k}(1,i);
end
Pmax{k}=max(Psegui{k});

%PARA DIBUJAR MODULOSquitar!!
for i=1:size(Psegui{k},2)
    if Psegui{k}(1,i)==max(Psegui{k})
        lugar=i;
    end
end
Vserreal{k}=Vsegui{k}(1,lugar);
for i=1:4
    [Iserreal{i}]=extrapola2ju(Vseries{k}(i,:),Iseries{k}(i,:),Vserreal{k});
end
for i=1:9
    if i==9
        [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{4});
    hold on
    plot(Vmodreal{i},Iserreal{4},'co');
    end
end

for i=10:18
    [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{3});
    hold on
    plot(Vmodreal{i},Iserreal{3},'go');
end
for i=19:27
    if i==19
    [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'bo');
    elseif i==20
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'go');
    elseif i==21
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'ro');
    elseif i==22
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'co');
    elseif i==23
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'yo');
    elseif i==24
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'ko');
    elseif i==25
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'mo');
    elseif i==26
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'bo');
    elseif i==27
         [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{2});
    hold on
    plot(Vmodreal{i},Iserreal{2},'go');
    end
end
for i=28:36   
    [Vmodreal{i}]=extrapola2ju(Itot{k}(i,:),Vtot{k}(i,:),Iserreal{4});
    hold on
    plot(Vmodreal{i},Iserreal{4},'ko');
end

%para dibujar tambien las series.
figure
for i=1:ser
    if i==1
     plot(Vseries{k}(i,:),Iseries{k}(i,:),'c');
hold on
plot(Vserreal{k},Iserreal{i},'ko');
hold on
    elseif i==2
plot(Vseries{k}(i,:),Iseries{k}(i,:),'g');
hold on

plot(Vserreal{k},Iserreal{i},'ko');
hold on
elseif i==3
plot(Vseries{k}(i,:),Iseries{k}(i,:),'b');
hold on
plot(Vserreal{k},Iserreal{i},'ko');
hold on
elseif i==4
plot(Vseries{k}(i,:),Iseries{k}(i,:),'r');
hold on
plot(Vserreal{k},Iserreal{i},'ko');
hold on
    end
for t=1:size(Vseries{k},2)
Pseries{k}(i,t)=Vseries{k}(i,t)*Iseries{k}(i,t);
end
for t=1:size(Pseries{k},2)
    if Pseries{k}(i,t)==max(Pseries{k}(i,:))
        plot(Vseries{k}(i,t),Iseries{k}(i,t),'b*');
        hold on
    end
end
end
%FIN DIBUJAR MOD.quitar!!

%Lo paso a excel
%celda{1,1}=['V',segui{1,k},'(Sinordenju)'];
%celda{1,2}=['I',segui{1,k},'(Sinordenju)'];
%celda{1,3}=['P',segui{1,k},'(Sinordenju)kW'];
%celda{size(Vsegui{k},2)+3,3}=['P.max',segui{1,k}];
%celda{size(Vsegui{k},2)+4,3}=Pmax{k};
%for i=1:size(Vsegui{k},2)
%    celda{i+1,1}=Vsegui{k}(1,i);
%    celda{i+1,2}=Isegui{k}(1,i); 
%    celda{i+1,3}=Psegui{k}(1,i);
%end
%
%if n==1
%rango='A1';
%elseif n==2
%    rango='E1';
%elseif n==3
%    rango='I1';
%elseif n==4
%    rango='M1';
%elseif n==5
%    rango='Q1';
%elseif n==6
%    rango='U1';
%elseif n==7
%    rango='Y1';
%elseif n==8
%    rango='AC1';
%elseif n==9
%    rango='AG1';
%elseif n==10
%    rango='AK1';
%end
%n=n+1;
%nombre_hoja='seguidores';
%xlswrite(['C:\Users\usuario\Desktop\pfc\ESTUDIOS\SINORDENJUU'],celda,nombre_hoja,rango);
end

end

