% y=extrapola2(X,Y,x)
% Esta funcion interpola o extrapola, segun sea necesario, el valor y que corresponde al valor x. y es un valor contenido dentro
% del array Y. A su vez el valor x esta contenido dentro del array X.
 
function [y]=extrapola2ju(X,Y,x)   %halla el valor de y para un vorlor de x, extrapolando o interpolandola curva X-Y.(mirar dibujo)

ult=length(X);

if X(1)<X(ult), 
        caso=1;   % X en orden creciente: son corrientes
    else caso=ult;            % X en orden decreciente: son tensiones
end
            
    % EXTRAPOLACIONES
%     if x<=X(caso),        
%         if caso==1, y=Y(1)+(Y(1)-Y(2))*(X(1)-x)/(X(2)-X(1));   % suponemos que la corriente se mantiene cte (potencia lineal)
%         else, y=Y(ult);
%         end
%     elseif x>X(1+ult-caso),
%         if caso==1,y=Y(ult)-(x-X(ult))*(Y(ult-1)-Y(ult))/(X(ult)-X(ult-1));
%         else, y=Y(1)-(Y(2)-Y(1))*(x-X(1))/(X(1)-X(2));
%         end
% REALIZADO POR JESS PARA EXTRAPOLAR.

    if x<=X(caso), 
        
        if caso==1, %Es decir, si las valores de abcisa son en orden ascendente y quiero conocer un valor que este antes de comenzar la grafica(izqu.)
            X1=X(1:60);%coge los 50primero valores de abcisas.
            Y1=Y(1:60); 
            P1=polyfit(X1,Y1,1); %Los ajusta aun polinomio de grado 1(recta).
            y=polyval(P1,x);%y calcula el valor de y de ese polinomio para el valor x de abcisas.
            
        else y=Y(ult);%porque s considera cte.(supongo).
        end
        
    elseif x>X(1+ult-caso),
        
        if caso==1, %Es decir,si x es mayor que el ultimo valor medido y el eje de abcisas es ascendente.
            X2=X(length(X)-2:length(X));%Coge los dos ultimos valores medidos de abcisas.
            Y2=Y(length(X)-2:length(X));
            P2=polyfit(X2,Y2,1); %ajusta a un polinomio de grado1(recta).
            if abs(P2(1))>=1e10, 
                y=0; %supongo que porque la pendiente es muy grande.
            else y=polyval(P2,x);
            end
        else, X3=X(1:50);
            Y3=Y(1:50); 
            P3=polyfit(X3,Y3,1); 
            y=polyval(P3,x);
        end
            

    % INTERPOLACIONES
    else
        % calculamos los dos puntos mas cercanos
        if caso==1,
            d=max(find(x>X));%Coge el maximo de los valores medidos menores que x.
        else
            d=min(find(x>X))-1;%mirar dibujo, es igual.
        end
        % interpolamos
        xa=X(d);
        xb=X(d+1);
        ya=Y(d);
        yb=Y(d+1);
        if xa==xb,
            y=(ya+yb)/2;
        else, try 
                y=ya+(yb-ya)*(x-xa)/(xb-xa); 
              catch
                para=1;
             end
        end
    end